/**
  ******************************************************************************
  * @file    stm32Hal.h
  * @author  MCD Application Team
  * @version V2.0.0
  * @date    11-July-2011
  * @brief   This file contains all 
  ******************************************************************************
  * @attention
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
  ******************************************************************************
  */

/* Define to prevent recursive inclusion ---------------------------------------*/
#ifndef __STM32_HAL_H
#define __STM32_HAL_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes --------------------------------------------------------------------*/
#if defined(STM32F4XX)
#include "stm32f4xx.h"
#elif defined(STM32F2XX)
#include "stm32f2xx.h"
#elif defined(STM32L1XX_MD)
#include "stm32l1xx.h"   
#else/* Suppose F1 Series */
#include "stm32f10x.h"
#endif 


#ifdef __cplusplus
}
#endif

#endif /*__STM32_HAL_H*/



/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
